from ons_metadata_validation.reference.constants import (
    MetaMapper,
    SheetMapper,
    SupplyType,
)

V2_TEMPLATE = {
    MetaMapper.DATASET_dataset_resource_name.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Dataset Resource Name",
        "ref_cell": "C6",
        "value_cell": "F6",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_resource_name.value,
    },
    MetaMapper.DATASET_acronym.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Acronym",
        "ref_cell": "C7",
        "value_cell": "F7",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_acronym.value,
    },
    MetaMapper.DATASET_significant_changes.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Significant Changes",
        "ref_cell": "C8",
        "value_cell": "F8",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_significant_changes.value,
    },
    MetaMapper.DATASET_data_creator.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Data Creator",
        "ref_cell": "C9",
        "value_cell": "F9",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_creator.value,
    },
    MetaMapper.DATASET_data_contributor_s.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Data Contributor(s)",
        "ref_cell": "C10",
        "value_cell": "F10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_contributor_s.value,
    },
    MetaMapper.DATASET_purpose_of_this_dataset_resource.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Purpose of this Dataset Resource",
        "ref_cell": "C11",
        "value_cell": "F11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_purpose_of_this_dataset_resource.value,
    },
    MetaMapper.DATASET_search_keywords.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Search keywords",
        "ref_cell": "C12",
        "value_cell": "F12",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_search_keywords.value,
    },
    MetaMapper.DATASET_dataset_theme.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Dataset Theme",
        "ref_cell": "C13",
        "value_cell": "F13",
        "mandatory": True,
        "enum": [
            "Business and economy",
            "Crime and justice",
            "Defence",
            "Education",
            "Environment",
            "Government",
            "Government spending",
            "Health",
            "Mapping",
            "Society",
            "Towns and cities",
            "Transport",
            "Digital service performance",
            "Government reference data",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_theme.value,
    },
    MetaMapper.DATASET_geographic_level.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Geographic Level",
        "ref_cell": "C14",
        "value_cell": "F14",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_geographic_level.value,
    },
    MetaMapper.DATASET_provenance.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Provenance",
        "ref_cell": "C15",
        "value_cell": "F15",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_provenance.value,
    },
    MetaMapper.DATASET_number_of_dataset_series.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Number of Dataset Series",
        "ref_cell": "C18",
        "value_cell": "F18",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_dataset_series.value,
    },
    MetaMapper.DATASET_number_of_structural_data_files.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Number of structural data files",
        "ref_cell": "C19",
        "value_cell": "F19",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_structural_data_files.value,
    },
    MetaMapper.DATASET_date_of_completion.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Date of completion",
        "ref_cell": "C20",
        "value_cell": "F20",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_date_of_completion.value,
    },
    MetaMapper.DATASET_name_and_email_of_individual_completing_this_template.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Name and email of individual completing this template",
        "ref_cell": "C21",
        "value_cell": "F21",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_name_and_email_of_individual_completing_this_template.value,
    },
    MetaMapper.DATASET_security_classification.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Security Classification",
        "ref_cell": "C24",
        "value_cell": "F24",
        "mandatory": True,
        "enum": [
            "Official",
            "Official-Sensitive",
            "Secret",
            "Top Secret",
            "Non-Applicable",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_security_classification.value,
    },
    MetaMapper.DATASET_dataset_resource_type.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Dataset Resource type",
        "ref_cell": "C25",
        "value_cell": "F25",
        "mandatory": True,
        "enum": [
            SheetMapper.SERIES.value,
            "Longitudinal",
            "Survey",
            "Statistical Output - Experimental",
            "Statistical Output - Key",
            "Statistical Output - National",
            "Reference",
            "Code List",
            "Administrative",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_resource_type.value,
    },
    MetaMapper.DATASET_number_of_non_structural_reference_files.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Number of non-structural/reference files ",
        "ref_cell": "C26",
        "value_cell": "F26",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_non_structural_reference_files.value,
    },
    MetaMapper.DATASET_number_of_code_list_files.value: {
        "tab": SheetMapper.RESOURCE.value,
        "name": "Number of code list files",
        "ref_cell": "C27",
        "value_cell": "F27",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_code_list_files.value,
    },
    MetaMapper.SERIES_dataset_series_name.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Dataset Series Name",
        "ref_cell": "C7",
        "value_cell": "C11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_dataset_series_name.value,
    },
    MetaMapper.SERIES_google_cloud_platform_bigquery_table_name.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Google Cloud Platform BigQuery Table Name",
        "ref_cell": "D7",
        "value_cell": "D11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.SERIES_description.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Description",
        "ref_cell": "E7",
        "value_cell": "E11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_description.value,
    },
    MetaMapper.SERIES_reference_period.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Reference Period",
        "ref_cell": "F7",
        "value_cell": "F11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_reference_period.value,
    },
    MetaMapper.SERIES_geographic_coverage.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Geographic Coverage",
        "ref_cell": "G7",
        "value_cell": "G11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_geographic_coverage.value,
    },
    MetaMapper.SERIES_frequency.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Frequency",
        "ref_cell": "H7",
        "value_cell": "H11",
        "mandatory": True,
        "enum": [
            "Annual",
            "Biennial",
            "Bimonthly",
            "Biweekly",
            "Continuous",
            "Daily",
            "Historical",
            "Irregular",
            "Monthly",
            "Periodic",
            "Quarterly",
            "Real Time",
            "Semiannual",
            "Semimonthly",
            "Semiweekly",
            "Single",
            "Three times a month",
            "Three times a week",
            "Three times a year",
            "Triennial",
            "Weekly",
        ],
        "datatype": str,
        "std_name": MetaMapper.SERIES_frequency.value,
    },
    MetaMapper.SERIES_supply_type.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Supply Type",
        "ref_cell": "I7",
        "value_cell": "I11",
        "mandatory": True,
        "enum": [SupplyType.FULL.value, SupplyType.APPEND.value],
        "datatype": str,
        "std_name": MetaMapper.SERIES_supply_type.value,
    },
    MetaMapper.SERIES_wave_number_time_period_covered_survey_only.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Wave number/time period covered (Survey only)",
        "ref_cell": "J7",
        "value_cell": "J11",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_wave_number_time_period_covered_survey_only.value,
    },
    MetaMapper.SERIES_links_to_online_documentation_and_other_useful_materials.value: {
        "tab": SheetMapper.SERIES.value,
        "name": "Links to online documentation and other useful materials",
        "ref_cell": "K7",
        "value_cell": "K11",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_links_to_online_documentation_and_other_useful_materials.value,
    },
    MetaMapper.FILE_google_cloud_platform_bigquery_table_name.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Google Cloud Platform BigQuery Table Name",
        "ref_cell": "C7",
        "value_cell": "C11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.FILE_file_path_and_name.value: {
        "tab": SheetMapper.FILE.value,
        "name": "File path and name",
        "ref_cell": "D7",
        "value_cell": "D11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_path_and_name.value,
    },
    MetaMapper.FILE_file_format.value: {
        "tab": SheetMapper.FILE.value,
        "name": "File Format",
        "ref_cell": "E7",
        "value_cell": "E11",
        "mandatory": True,
        "enum": ["CSV", "JSON", "PARQUET", "JSON Multi-Line"],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_format.value,
    },
    MetaMapper.FILE_column_seperator.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Column Seperator",
        "ref_cell": "F7",
        "value_cell": "F11",
        "mandatory": False,
        "enum": [",", "|", "\\t"],
        "datatype": str,
        "std_name": MetaMapper.FILE_column_seperator.value,
    },
    MetaMapper.FILE_string_identifier.value: {
        "tab": SheetMapper.FILE.value,
        "name": "String identifier",
        "ref_cell": "G7",
        "value_cell": "G11",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_string_identifier.value,
    },
    MetaMapper.FILE_file_description.value: {
        "tab": SheetMapper.FILE.value,
        "name": "File description",
        "ref_cell": "H7",
        "value_cell": "H11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_description.value,
    },
    MetaMapper.FILE_reference_period.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Reference period",
        "ref_cell": "I7",
        "value_cell": "I11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_reference_period.value,
    },
    MetaMapper.FILE_file_size.value: {
        "tab": SheetMapper.FILE.value,
        "name": "File size",
        "ref_cell": "J7",
        "value_cell": "J11",
        "mandatory": True,
        "enum": [],
        "datatype": float,
        "std_name": MetaMapper.FILE_file_size.value,
    },
    MetaMapper.FILE_file_size_unit.value: {
        "tab": SheetMapper.FILE.value,
        "name": "File size unit",
        "ref_cell": "K7",
        "value_cell": "K11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_size_unit.value,
    },
    MetaMapper.FILE_is_code_list.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Is code list",
        "ref_cell": "L7",
        "value_cell": "L11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_is_code_list.value,
    },
    MetaMapper.FILE_number_of_records.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Number of records",
        "ref_cell": "M7",
        "value_cell": "M11",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.FILE_number_of_records.value,
    },
    MetaMapper.FILE_is_this_file_one_of_a_sequence_to_be_appended_back_together.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Is this file one of a sequence to be appended back together?",
        "ref_cell": "N7",
        "value_cell": "N11",
        "mandatory": True,
        "enum": ["Yes", "No"],
        "datatype": str,
        "std_name": MetaMapper.FILE_is_this_file_one_of_a_sequence_to_be_appended_back_together.value,
    },
    MetaMapper.FILE_number_of_header_rows.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Number of header rows",
        "ref_cell": "O7",
        "value_cell": "O11",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.FILE_number_of_header_rows.value,
    },
    MetaMapper.FILE_number_of_footer_rows.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Number of footer rows",
        "ref_cell": "P7",
        "value_cell": "P11",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.FILE_number_of_footer_rows.value,
    },
    MetaMapper.FILE_character_encoding.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Character encoding",
        "ref_cell": "Q7",
        "value_cell": "Q11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_character_encoding.value,
    },
    MetaMapper.FILE_hash_value_for_checksum.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Hash value for checksum",
        "ref_cell": "R7",
        "value_cell": "R11",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_hash_value_for_checksum.value,
    },
    MetaMapper.FILE_notes.value: {
        "tab": SheetMapper.FILE.value,
        "name": "Notes",
        "ref_cell": "S7",
        "value_cell": "S11",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_notes.value,
    },
    MetaMapper.VARS_google_cloud_platform_bigquery_table_name.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Google Cloud Platform BigQuery Table Name",
        "ref_cell": "C6",
        "value_cell": "C10",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.VARS_variable_name.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable name",
        "ref_cell": "D6",
        "value_cell": "D10",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_name.value,
    },
    MetaMapper.VARS_google_cloud_platform_compatible_variable_name.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Google Cloud Platform compatible variable name",
        "ref_cell": "E6",
        "value_cell": "E10",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_google_cloud_platform_compatible_variable_name.value,
    },
    MetaMapper.VARS_variable_label.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable label",
        "ref_cell": "F6",
        "value_cell": "F10",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_label.value,
    },
    MetaMapper.VARS_variable_description.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable description",
        "ref_cell": "G6",
        "value_cell": "G10",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_description.value,
    },
    MetaMapper.VARS_position_in_file.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Position in file",
        "ref_cell": "H6",
        "value_cell": "H10",
        "mandatory": False,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.VARS_position_in_file.value,
    },
    MetaMapper.VARS_personally_identifiable_information.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Personally Identifiable Information",
        "ref_cell": "I6",
        "value_cell": "I10",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_personally_identifiable_information.value,
    },
    MetaMapper.VARS_variable_data_type.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable Data Type",
        "ref_cell": "J6",
        "value_cell": "J10",
        "mandatory": True,
        "enum": [
            "ARRAY",
            "ARRAYTYPE",
            "BIGINT",
            "BOOLEAN",
            "BOOLEANTYPE",
            "CLOB",
            "DATE",
            "DATETIME",
            "DATETYPE",
            "DECIMAL",
            "DECIMALTYPE",
            "DOUBLE",
            "DOUBLETYPE",
            "FLOAT",
            "INT",
            "INT16",
            "INT32",
            "INT64",
            "INT8",
            "INTEGER",
            "INTEGERTYPE",
            "LONG",
            "LONGTEXT",
            "LONGTYPE",
            "MAP",
            "MAPTYPE",
            "SHORTTEXT",
            "SMALLINT",
            "STR",
            "STRING",
            "STRINGTYPE",
            "STRUCT",
            "STRUCTTYPE",
            "TEXT",
            "TIME",
            "TIMESTAMP",
            "TIMESTAMPTYPE",
            "TINYINT",
            "UNICODESTRING",
        ],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_data_type.value,
    },
    MetaMapper.VARS_gcp_data_type.value: {
        "tab": SheetMapper.VARS.value,
        "name": "GCP Data Type",
        "ref_cell": "K6",
        "value_cell": "K10",
        "mandatory": True,
        "enum": [
            "ARRAY",
            "BIGNUMBER",
            "BOOL",
            "DATE",
            "FLOAT64",
            "INT64",
            "INTERVAL",
            "STRING",
            "TIME",
            "TIMESTAMP",
        ],
        "datatype": str,
        "std_name": MetaMapper.VARS_gcp_data_type.value,
    },
    MetaMapper.VARS_variable_length_precision.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable length/precision",
        "ref_cell": "L6",
        "value_cell": "L10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_length_precision.value,
    },
    MetaMapper.VARS_variable_format.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable format",
        "ref_cell": "M6",
        "value_cell": "M10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_format.value,
    },
    MetaMapper.VARS_is_primary_key.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Is Primary Key",
        "ref_cell": "N6",
        "value_cell": "N10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_is_primary_key.value,
    },
    MetaMapper.VARS_is_foreign_key.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Is Foreign Key",
        "ref_cell": "O6",
        "value_cell": "O10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_is_foreign_key.value,
    },
    MetaMapper.VARS_foreign_key_file_name.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Foreign Key file name",
        "ref_cell": "P6",
        "value_cell": "P10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_foreign_key_file_name.value,
    },
    MetaMapper.VARS_foreign_key_variable_name.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Foreign Key variable name",
        "ref_cell": "Q6",
        "value_cell": "Q10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_foreign_key_variable_name.value,
    },
    MetaMapper.VARS_nullability.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Nullability",
        "ref_cell": "R6",
        "value_cell": "R10",
        "mandatory": True,
        "enum": ["NULL", "NOT NULL"],
        "datatype": str,
        "std_name": MetaMapper.VARS_nullability.value,
    },
    MetaMapper.VARS_null_values_denoted_by.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Null values denoted by",
        "ref_cell": "S6",
        "value_cell": "S10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_null_values_denoted_by.value,
    },
    MetaMapper.VARS_variable_constraints.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Variable constraints",
        "ref_cell": "T6",
        "value_cell": "T10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_constraints.value,
    },
    MetaMapper.VARS_applicable_business_rules.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Applicable business rules",
        "ref_cell": "U6",
        "value_cell": "U10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_applicable_business_rules.value,
    },
    MetaMapper.VARS_is_this_a_code.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Is this a code?",
        "ref_cell": "V6",
        "value_cell": "V10",
        "mandatory": True,
        "enum": ["Yes", "No"],
        "datatype": str,
        "std_name": MetaMapper.VARS_is_this_a_code.value,
    },
    MetaMapper.VARS_notes.value: {
        "tab": SheetMapper.VARS.value,
        "name": "Notes",
        "ref_cell": "W6",
        "value_cell": "W10",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_notes.value,
    },
    MetaMapper.CODES_google_cloud_platform_bigquery_table_name.value: {
        "tab": SheetMapper.CODES.value,
        "name": "Google Cloud Platform BigQuery Table Name",
        "ref_cell": "C5",
        "value_cell": "C8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.CODES_variable_name.value: {
        "tab": SheetMapper.CODES.value,
        "name": "Variable name",
        "ref_cell": "D5",
        "value_cell": "D8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_variable_name.value,
    },
    MetaMapper.CODES_key.value: {
        "tab": SheetMapper.CODES.value,
        "name": "Key",
        "ref_cell": "E5",
        "value_cell": "E8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_key.value,
    },
    MetaMapper.CODES_value.value: {
        "tab": SheetMapper.CODES.value,
        "name": "Value",
        "ref_cell": "F5",
        "value_cell": "F8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_value.value,
    },
    MetaMapper.CODES_notes.value: {
        "tab": SheetMapper.CODES.value,
        "name": "Notes",
        "ref_cell": "G5",
        "value_cell": "G8",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_notes.value,
    },
    MetaMapper.DATASET_ids_business_catalogue_identifier.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "IDS Business Catalogue Identifier",
        "ref_cell": "C14",
        "value_cell": "F14",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_ids_business_catalogue_identifier.value,
    },
    MetaMapper.DATASET_description.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Description",
        "ref_cell": "C15",
        "value_cell": "F15",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_description.value,
    },
    MetaMapper.DATASET_abstract.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Abstract",
        "ref_cell": "C16",
        "value_cell": "F16",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_abstract.value,
    },
    MetaMapper.DATASET_google_cloud_platform_project_name.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Google Cloud Platform Project name",
        "ref_cell": "C17",
        "value_cell": "F17",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_google_cloud_platform_project_name.value,
    },
    MetaMapper.DATASET_google_cloud_platform_big_query_dataset_name.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Google Cloud Platform Big Query Dataset name",
        "ref_cell": "C18",
        "value_cell": "F18",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_google_cloud_platform_big_query_dataset_name.value,
    },
    MetaMapper.DATASET_other_unique_identifier_s_for_dataset_resource.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Other Unique Identifier(s) for Dataset Resource",
        "ref_cell": "C19",
        "value_cell": "F19",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_other_unique_identifier_s_for_dataset_resource.value,
    },
    MetaMapper.DATASET_frequency.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Frequency ",
        "ref_cell": "C20",
        "value_cell": "F20",
        "mandatory": True,
        "enum": [
            "Annual",
            "Biennial",
            "Bimonthly",
            "Biweekly",
            "Continuous",
            "Daily",
            "Historical",
            "Irregular",
            "Monthly",
            "Periodic",
            "Quarterly",
            "Real Time",
            "Semiannual",
            "Semimonthly",
            "Semiweekly",
            "Single",
            "Three times a month",
            "Three times a week",
            "Three times a year",
            "Triennial",
            "Weekly",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_frequency.value,
    },
    MetaMapper.DATASET_geographic_coverage.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Geographic Coverage",
        "ref_cell": "C21",
        "value_cell": "F21",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_geographic_coverage.value,
    },
    MetaMapper.DATASET_temporal_coverage.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Temporal Coverage",
        "ref_cell": "C22",
        "value_cell": "F22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_temporal_coverage.value,
    },
    MetaMapper.DATASET_sensitivity_status_for_dataset_resource.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Sensitivity status for Dataset Resource",
        "ref_cell": "C23",
        "value_cell": "F23",
        "mandatory": True,
        "enum": ["Low", "Medium", "High"],
        "datatype": str,
        "std_name": MetaMapper.DATASET_sensitivity_status_for_dataset_resource.value,
    },
    MetaMapper.DATASET_sensitivity_tool_url.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Sensitivity tool URL",
        "ref_cell": "C24",
        "value_cell": "F24",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_sensitivity_tool_url.value,
    },
    MetaMapper.DATASET_retention_date.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Retention Date",
        "ref_cell": "C25",
        "value_cell": "F25",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_retention_date.value,
    },
    MetaMapper.DATASET_provider_statement_for_retention_removal_or_deletion.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Provider statement for retention, removal or deletion",
        "ref_cell": "C26",
        "value_cell": "F26",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_provider_statement_for_retention_removal_or_deletion.value,
    },
    MetaMapper.DATASET_removal_date.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Removal Date",
        "ref_cell": "C27",
        "value_cell": "F27",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_removal_date.value,
    },
    MetaMapper.DATASET_removal_comments.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Removal Comments",
        "ref_cell": "C28",
        "value_cell": "F28",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_removal_comments.value,
    },
    MetaMapper.DATASET_data_controller.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Data Controller",
        "ref_cell": "C29",
        "value_cell": "F29",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_controller.value,
    },
    MetaMapper.DATASET_data_processor.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Data Processor",
        "ref_cell": "C30",
        "value_cell": "F30",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_processor.value,
    },
    MetaMapper.DATASET_dataset_domain.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Dataset Domain",
        "ref_cell": "C31",
        "value_cell": "F31",
        "mandatory": True,
        "enum": [
            "Crime and Justice",
            "Economics",
            "Government finance, Fiscal and Public Sector finances",
            "Human settlements and housing",
            "Income and Consumption",
            "Education ",
            "Health ",
            "Labour",
            "Population and Migration",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_domain.value,
    },
    MetaMapper.DATASET_legal_gateway.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Legal Gateway",
        "ref_cell": "C32",
        "value_cell": "F32",
        "mandatory": False,
        "enum": [
            "Digital Economy Act 2017",
            "Statistics and Registration Service Act 2007",
            "NHS Act 2006",
            "NHS Act 2006 with COPI Regulations 2002, Reg 3(4)",
            "Health and Social Care Act 2012",
            "Education Act 1996 / 2011",
            "Education and Skills Act 2008",
            "Children's Act 1989",
            "Legal Gateway Not Required",
            "Other",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_legal_gateway.value,
    },
    MetaMapper.DATASET_other_legal_gateway.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Other Legal Gateway",
        "ref_cell": "C33",
        "value_cell": "F33",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_other_legal_gateway.value,
    },
    MetaMapper.DATASET_licensing_status.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Licensing status",
        "ref_cell": "C34",
        "value_cell": "F34",
        "mandatory": False,
        "enum": [
            "Open Data Commons Open Database License (ODbL)",
            "Open Government Licence v3.0",
            "Open Government Licence v2.0",
            "Open Government Licence v1.0",
            "Statistics and Registration Service Act 2007",
            "Non-Commercial Government Licence v2.0",
            "Non-Commercial Government Licence v1.0",
            "Developer Licence 2.0",
            "Developer Licence 1.0",
            "Charged Licence",
            "Open Supreme Court Licence",
            "Restricted",
            "Memorandum of Understanding (MoU)",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_licensing_status.value,
    },
    MetaMapper.DATASET_metadata_access.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Metadata Access",
        "ref_cell": "C35",
        "value_cell": "F35",
        "mandatory": True,
        "enum": [
            "Publish to Website and Hub",
            "Publish to Hub only",
            "Do not publish",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_metadata_access.value,
    },
    MetaMapper.DATASET_documentation.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Documentation",
        "ref_cell": "C36",
        "value_cell": "F36",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_documentation.value,
    },
    MetaMapper.DATASET_what_are_the_linkage_requirements_for_the_data_within_the_project_scope.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "What are the linkage requirements for the data within the project scope?",
        "ref_cell": "C37",
        "value_cell": "F37",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_what_are_the_linkage_requirements_for_the_data_within_the_project_scope.value,
    },
    MetaMapper.DATASET_how_has_deidentification_been_achieved.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "How has deidentification been achieved?",
        "ref_cell": "C38",
        "value_cell": "F38",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_how_has_deidentification_been_achieved.value,
    },
    MetaMapper.DATASET_should_this_dataset_be_visible_for_internal_or_external_users.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Should this dataset be visible for internal or external users?",
        "ref_cell": "C39",
        "value_cell": "F39",
        "mandatory": True,
        "enum": ["Internal only", "Internal and External"],
        "datatype": str,
        "std_name": MetaMapper.DATASET_should_this_dataset_be_visible_for_internal_or_external_users.value,
    },
    MetaMapper.DATASET_restrictions_for_access.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Restrictions for Access",
        "ref_cell": "C40",
        "value_cell": "F40",
        "mandatory": True,
        "enum": [
            "Access for all accredited researchers",
            "Access limited to specific researchers",
            "Limited to specific individuals",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_restrictions_for_access.value,
    },
    MetaMapper.DATASET_research_outputs.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Research Outputs",
        "ref_cell": "C41",
        "value_cell": "F41",
        "mandatory": True,
        "enum": [
            "Research outputs must be sent to the data owner",
            "Research outputs must be approved by the data owner",
            "No requirements",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_research_outputs.value,
    },
    MetaMapper.DATASET_project_approval.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Project Approval",
        "ref_cell": "C42",
        "value_cell": "F42",
        "mandatory": True,
        "enum": [
            "Projects must be accredited and have approval from the data owner",
            "Projects must be accredited",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_project_approval.value,
    },
    MetaMapper.DATASET_disclosure_control.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Disclosure Control",
        "ref_cell": "C43",
        "value_cell": "F43",
        "mandatory": True,
        "enum": [
            "Standard disclosure rules apply",
            "Bespoke disclosure rules apply",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_disclosure_control.value,
    },
    MetaMapper.DATASET_research_disclaimer.value: {
        "tab": SheetMapper.BACK_OFFICE.value,
        "name": "Research Disclaimer",
        "ref_cell": "C44",
        "value_cell": "F44",
        "mandatory": True,
        "enum": [
            "A disclaimer must be published with research outputs",
            "No requirements",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_research_disclaimer.value,
    },
}


V1_TEMPLATE = {
    MetaMapper.DATASET_dataset_resource_name.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Resource Name",
        "ref_cell": "B2",
        "value_cell": "F2",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_resource_name.value,
    },
    MetaMapper.DATASET_acronym.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Resource Acronym",
        "ref_cell": "B5",
        "value_cell": "F5",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_acronym.value,
    },
    MetaMapper.DATASET_significant_changes.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Resource Significant Changes",
        "ref_cell": "B6",
        "value_cell": "F6",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_significant_changes.value,
    },
    MetaMapper.DATASET_data_creator.value: {
        "tab": "Dataset Resource",
        "name": "Data Creator",
        "ref_cell": "B8",
        "value_cell": "F8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_creator.value,
    },
    MetaMapper.DATASET_data_contributor_s.value: {
        "tab": "Dataset Resource",
        "name": "Data Contributor(s)",
        "ref_cell": "B9",
        "value_cell": "F9",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_contributor_s.value,
    },
    MetaMapper.DATASET_purpose_of_this_dataset_resource.value: {
        "tab": "Dataset Resource",
        "name": "Purpose of this Dataset Resource",
        "ref_cell": "B15",
        "value_cell": "F15",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_purpose_of_this_dataset_resource.value,
    },
    MetaMapper.DATASET_search_keywords.value: {
        "tab": "Dataset Resource",
        "name": "Search keywords",
        "ref_cell": "B18",
        "value_cell": "F18",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_search_keywords.value,
    },
    MetaMapper.DATASET_dataset_theme.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Theme",
        "ref_cell": "B20",
        "value_cell": "F20",
        "mandatory": True,
        "enum": [
            "Business and economy",
            "Crime and justice",
            "Defence",
            "Education",
            "Environment",
            "Government",
            "Government spending",
            "Health",
            "Mapping",
            "Society",
            "Towns and cities",
            "Transport",
            "Digital service performance",
            "Government reference data",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_theme.value,
    },
    MetaMapper.DATASET_geographic_level.value: {
        "tab": "Dataset Resource",
        "name": "Geographic Level",
        "ref_cell": "B26",
        "value_cell": "F26",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_geographic_level.value,
    },
    MetaMapper.DATASET_provenance.value: {
        "tab": "Dataset Resource",
        "name": "Provenance",
        "ref_cell": "B99",
        "value_cell": "F99",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_provenance.value,
    },
    MetaMapper.DATASET_number_of_dataset_series.value: {
        "tab": "Dataset Resource",
        "name": "Number of Dataset Series",
        "ref_cell": "B101",
        "value_cell": "F101",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_dataset_series.value,
    },
    MetaMapper.DATASET_number_of_structural_data_files.value: {
        "tab": "Dataset Resource",
        "name": "Number of structural data files",
        "ref_cell": "B102",
        "value_cell": "F102",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_structural_data_files.value,
    },
    MetaMapper.DATASET_date_of_completion.value: {
        "tab": "Dataset Resource",
        "name": "Date of completion",
        "ref_cell": "B42",
        "value_cell": "F42",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_date_of_completion.value,
    },
    MetaMapper.DATASET_dataset_resource_type.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Resource type",
        "ref_cell": "B98",
        "value_cell": "F98",
        "mandatory": True,
        "enum": [
            "Dataset Series",
            "Longitudinal",
            "Survey",
            "Statistical Output - Experimental",
            "Statistical Output - Key",
            "Statistical Output - National",
            "Reference",
            "Code List",
            "Administrative",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_resource_type.value,
    },
    MetaMapper.DATASET_number_of_code_list_files.value: {
        "tab": "Dataset Resource",
        "name": "Number of code list files",
        "ref_cell": "B104",
        "value_cell": "F104",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.DATASET_number_of_code_list_files.value,
    },
    MetaMapper.SERIES_google_cloud_platform_bigquery_table_name.value: {
        "tab": "Dataset Series",
        "name": "Dataset Series Name",
        "ref_cell": "D2",
        "value_cell": "D8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.SERIES_description.value: {
        "tab": "Dataset Series",
        "name": "Dataset Series Description",
        "ref_cell": "E2",
        "value_cell": "E8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_description.value,
    },
    MetaMapper.SERIES_reference_period.value: {
        "tab": "Dataset Series",
        "name": "Dataset Series Reference Period",
        "ref_cell": "G2",
        "value_cell": "G8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_reference_period.value,
    },
    MetaMapper.SERIES_geographic_coverage.value: {
        "tab": "Dataset Series",
        "name": "Dataset Series Geographic Coverage",
        "ref_cell": "H2",
        "value_cell": "H8",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_geographic_coverage.value,
    },
    MetaMapper.SERIES_frequency.value: {
        "tab": "Dataset Series",
        "name": "Dataset Series Frequency",
        "ref_cell": "I2",
        "value_cell": "I8",
        "mandatory": True,
        "enum": [
            "Annual",
            "Biennial",
            "Bimonthly",
            "Biweekly",
            "Continuous",
            "Daily",
            "Historical",
            "Irregular",
            "Monthly",
            "Periodic",
            "Quarterly",
            "Real Time",
            "Semiannual",
            "Semimonthly",
            "Semiweekly",
            "Single",
            "Three times a month",
            "Three times a week",
            "Three times a year",
            "Triennial",
            "Weekly",
        ],
        "datatype": str,
        "std_name": MetaMapper.SERIES_frequency.value,
    },
    MetaMapper.SERIES_wave_number_time_period_covered_survey_only.value: {
        "tab": "Dataset Series",
        "name": "Dataset Resource Wave number/time period covered (Survey only)",
        "ref_cell": "M2",
        "value_cell": "M8",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_wave_number_time_period_covered_survey_only.value,
    },
    MetaMapper.SERIES_links_to_online_documentation_and_other_useful_materials.value: {
        "tab": "Dataset Series",
        "name": "Links to online documentation and other useful materials",
        "ref_cell": "O2",
        "value_cell": "O8",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.SERIES_links_to_online_documentation_and_other_useful_materials.value,
    },
    MetaMapper.FILE_google_cloud_platform_bigquery_table_name.value: {
        "tab": "Dataset File",
        "name": "Dataset Series",
        "ref_cell": "B1",
        "value_cell": "B23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.FILE_file_path_and_name.value: {
        "tab": "Dataset File",
        "name": "File path and name",
        "ref_cell": "C1",
        "value_cell": "C23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_path_and_name.value,
    },
    MetaMapper.FILE_file_format.value: {
        "tab": "Dataset File",
        "name": "File format",
        "ref_cell": "G1",
        "value_cell": "G23",
        "mandatory": True,
        "enum": ["CSV", "JSON", "PARQUET", "JSON Multi-Line"],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_format.value,
    },
    MetaMapper.FILE_string_identifier.value: {
        "tab": "Dataset File",
        "name": "String identifier",
        "ref_cell": "H1",
        "value_cell": "H23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_string_identifier.value,
    },
    MetaMapper.FILE_file_description.value: {
        "tab": "Dataset File",
        "name": "File description",
        "ref_cell": "I1",
        "value_cell": "I23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_description.value,
    },
    MetaMapper.FILE_reference_period.value: {
        "tab": "Dataset File",
        "name": "Reference period",
        "ref_cell": "L1",
        "value_cell": "L23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_reference_period.value,
    },
    MetaMapper.FILE_file_size.value: {
        "tab": "Dataset File",
        "name": "File size",
        "ref_cell": "M1",
        "value_cell": "M23",
        "mandatory": True,
        "enum": [],
        "datatype": float,
        "std_name": MetaMapper.FILE_file_size.value,
    },
    MetaMapper.FILE_file_size_unit.value: {
        "tab": "Dataset File",
        "name": "File size unit",
        "ref_cell": "N1",
        "value_cell": "N23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_file_size_unit.value,
    },
    MetaMapper.FILE_is_code_list.value: {
        "tab": "Dataset File",
        "name": "Is code list",
        "ref_cell": "R1",
        "value_cell": "R23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_is_code_list.value,
    },
    MetaMapper.FILE_number_of_records.value: {
        "tab": "Dataset File",
        "name": "Number of records",
        "ref_cell": "T1",
        "value_cell": "T23",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.FILE_number_of_records.value,
    },
    MetaMapper.FILE_is_this_file_one_of_a_sequence_to_be_appended_back_together.value: {
        "tab": "Dataset File",
        "name": "Is this file one of a sequence to be appended back together?",
        "ref_cell": "U1",
        "value_cell": "U23",
        "mandatory": True,
        "enum": ["Yes", "No"],
        "datatype": str,
        "std_name": MetaMapper.FILE_is_this_file_one_of_a_sequence_to_be_appended_back_together.value,
    },
    MetaMapper.FILE_number_of_header_rows.value: {
        "tab": "Dataset File",
        "name": "Number of header rows",
        "ref_cell": "V1",
        "value_cell": "V23",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.FILE_number_of_header_rows.value,
    },
    MetaMapper.FILE_number_of_footer_rows.value: {
        "tab": "Dataset File",
        "name": "Number of footer rows",
        "ref_cell": "W1",
        "value_cell": "W23",
        "mandatory": True,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.FILE_number_of_footer_rows.value,
    },
    MetaMapper.FILE_character_encoding.value: {
        "tab": "Dataset File",
        "name": "Character encoding",
        "ref_cell": "AB1",
        "value_cell": "AB23",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_character_encoding.value,
    },
    MetaMapper.FILE_hash_value_for_checksum.value: {
        "tab": "Dataset File",
        "name": "Hash value for checksum",
        "ref_cell": "AD1",
        "value_cell": "AD23",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_hash_value_for_checksum.value,
    },
    MetaMapper.FILE_notes.value: {
        "tab": "Dataset File",
        "name": "Notes",
        "ref_cell": "AF1",
        "value_cell": "AF23",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.FILE_notes.value,
    },
    MetaMapper.VARS_google_cloud_platform_bigquery_table_name.value: {
        "tab": "Variables",
        "name": "Dataset Series",
        "ref_cell": "B1",
        "value_cell": "B22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.VARS_variable_name.value: {
        "tab": "Variables",
        "name": "Variable name",
        "ref_cell": "D1",
        "value_cell": "D22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_name.value,
    },
    MetaMapper.VARS_variable_label.value: {
        "tab": "Variables",
        "name": "Variable label",
        "ref_cell": "E1",
        "value_cell": "E22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_label.value,
    },
    MetaMapper.VARS_variable_description.value: {
        "tab": "Variables",
        "name": "Variable description",
        "ref_cell": "F1",
        "value_cell": "F22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_description.value,
    },
    MetaMapper.VARS_position_in_file.value: {
        "tab": "Variables",
        "name": "Position in file",
        "ref_cell": "G1",
        "value_cell": "G22",
        "mandatory": False,
        "enum": [],
        "datatype": int,
        "std_name": MetaMapper.VARS_position_in_file.value,
    },
    MetaMapper.VARS_personally_identifiable_information.value: {
        "tab": "Variables",
        "name": "Personally Identifiable Information",
        "ref_cell": "H1",
        "value_cell": "H22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_personally_identifiable_information.value,
    },
    MetaMapper.VARS_variable_data_type.value: {
        "tab": "Variables",
        "name": "Variable data type",
        "ref_cell": "I1",
        "value_cell": "I22",
        "mandatory": True,
        "enum": [
            "ARRAY",
            "ARRAYTYPE",
            "BIGINT",
            "BOOLEAN",
            "BOOLEANTYPE",
            "CLOB",
            "DATE",
            "DATETIME",
            "DATETYPE",
            "DECIMAL",
            "DECIMALTYPE",
            "DOUBLE",
            "DOUBLETYPE",
            "FLOAT",
            "INT",
            "INT16",
            "INT32",
            "INT64",
            "INT8",
            "INTEGER",
            "INTEGERTYPE",
            "LONG",
            "LONGTEXT",
            "LONGTYPE",
            "MAP",
            "MAPTYPE",
            "SHORTTEXT",
            "SMALLINT",
            "STR",
            "STRING",
            "STRINGTYPE",
            "STRUCT",
            "STRUCTTYPE",
            "TEXT",
            "TIME",
            "TIMESTAMP",
            "TIMESTAMPTYPE",
            "TINYINT",
            "UNICODESTRING",
        ],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_data_type.value,
    },
    MetaMapper.VARS_gcp_data_type.value: {
        "tab": "Variables",
        "name": "GCP Data Type",
        "ref_cell": "J1",
        "value_cell": "J22",
        "mandatory": True,
        "enum": [
            "ARRAY",
            "BIGNUMBER",
            "BOOL",
            "DATE",
            "FLOAT64",
            "INT64",
            "INTERVAL",
            "STRING",
            "TIME",
            "TIMESTAMP",
        ],
        "datatype": str,
        "std_name": MetaMapper.VARS_gcp_data_type.value,
    },
    MetaMapper.VARS_variable_length_precision.value: {
        "tab": "Variables",
        "name": "Variable length/precision",
        "ref_cell": "K1",
        "value_cell": "K22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_length_precision.value,
    },
    MetaMapper.VARS_variable_format.value: {
        "tab": "Variables",
        "name": "Variable format",
        "ref_cell": "L1",
        "value_cell": "L22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_format.value,
    },
    MetaMapper.VARS_is_primary_key.value: {
        "tab": "Variables",
        "name": "Is Primary Key",
        "ref_cell": "M1",
        "value_cell": "M22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_is_primary_key.value,
    },
    MetaMapper.VARS_is_foreign_key.value: {
        "tab": "Variables",
        "name": "Is Foreign Key",
        "ref_cell": "N1",
        "value_cell": "N22",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_is_foreign_key.value,
    },
    MetaMapper.VARS_foreign_key_file_name.value: {
        "tab": "Variables",
        "name": "Foreign Key file name",
        "ref_cell": "O1",
        "value_cell": "O22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_foreign_key_file_name.value,
    },
    MetaMapper.VARS_foreign_key_variable_name.value: {
        "tab": "Variables",
        "name": "Foreign Key variable name",
        "ref_cell": "P1",
        "value_cell": "P22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_foreign_key_variable_name.value,
    },
    MetaMapper.VARS_nullability.value: {
        "tab": "Variables",
        "name": "Nullability",
        "ref_cell": "Q1",
        "value_cell": "Q22",
        "mandatory": True,
        "enum": ["NULL", "NOT NULL"],
        "datatype": str,
        "std_name": MetaMapper.VARS_nullability.value,
    },
    MetaMapper.VARS_null_values_denoted_by.value: {
        "tab": "Variables",
        "name": "NULL values denoted by",
        "ref_cell": "R1",
        "value_cell": "R22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_null_values_denoted_by.value,
    },
    MetaMapper.VARS_variable_constraints.value: {
        "tab": "Variables",
        "name": "Variable constraints",
        "ref_cell": "S1",
        "value_cell": "S22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_variable_constraints.value,
    },
    MetaMapper.VARS_applicable_business_rules.value: {
        "tab": "Variables",
        "name": "Applicable business rules",
        "ref_cell": "T1",
        "value_cell": "T22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_applicable_business_rules.value,
    },
    MetaMapper.VARS_is_this_a_code.value: {
        "tab": "Variables",
        "name": "Is this a code?",
        "ref_cell": "U1",
        "value_cell": "U22",
        "mandatory": True,
        "enum": ["Yes", "No"],
        "datatype": str,
        "std_name": MetaMapper.VARS_is_this_a_code.value,
    },
    MetaMapper.VARS_notes.value: {
        "tab": "Variables",
        "name": "Notes",
        "ref_cell": "Z1",
        "value_cell": "Z22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.VARS_notes.value,
    },
    MetaMapper.CODES_google_cloud_platform_bigquery_table_name.value: {
        "tab": "Codes and Values",
        "name": "Dataset Series",
        "ref_cell": "B1",
        "value_cell": "B17",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_google_cloud_platform_bigquery_table_name.value,
    },
    MetaMapper.CODES_variable_name.value: {
        "tab": "Codes and Values",
        "name": "Variable name",
        "ref_cell": "D1",
        "value_cell": "D17",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_variable_name.value,
    },
    MetaMapper.CODES_key.value: {
        "tab": "Codes and Values",
        "name": "Key",
        "ref_cell": "E1",
        "value_cell": "E17",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_key.value,
    },
    MetaMapper.CODES_value.value: {
        "tab": "Codes and Values",
        "name": "Value",
        "ref_cell": "F1",
        "value_cell": "F17",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_value.value,
    },
    MetaMapper.CODES_notes.value: {
        "tab": "Codes and Values",
        "name": "Notes",
        "ref_cell": "G1",
        "value_cell": "G17",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.CODES_notes.value,
    },
    MetaMapper.DATASET_ids_business_catalogue_identifier.value: {
        "tab": "Dataset Resource",
        "name": "IDS Business Catalogue Identifier",
        "ref_cell": "B21",
        "value_cell": "F21",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_ids_business_catalogue_identifier.value,
    },
    MetaMapper.DATASET_description.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Resource Description",
        "ref_cell": "B3",
        "value_cell": "F3",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_description.value,
    },
    MetaMapper.DATASET_abstract.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Resource Abstract",
        "ref_cell": "B4",
        "value_cell": "F4",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_abstract.value,
    },
    MetaMapper.DATASET_google_cloud_platform_project_name.value: {
        "tab": "Dataset Resource",
        "name": "Google Cloud Platform: Project name",
        "ref_cell": "B45",
        "value_cell": "F45",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_google_cloud_platform_project_name.value,
    },
    MetaMapper.DATASET_google_cloud_platform_big_query_dataset_name.value: {
        "tab": "Dataset Resource",
        "name": "Google Cloud Platform: Dataset name",
        "ref_cell": "B46",
        "value_cell": "F46",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_google_cloud_platform_big_query_dataset_name.value,
    },
    MetaMapper.DATASET_other_unique_identifier_s_for_dataset_resource.value: {
        "tab": "Dataset Resource",
        "name": "Other Unique Identifier(s) for Dataset Resource",
        "ref_cell": "B22",
        "value_cell": "F22",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_other_unique_identifier_s_for_dataset_resource.value,
    },
    MetaMapper.DATASET_geographic_coverage.value: {
        "tab": "Dataset Resource",
        "name": "Geographic Coverage",
        "ref_cell": "B25",
        "value_cell": "F25",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_geographic_coverage.value,
    },
    MetaMapper.DATASET_temporal_coverage.value: {
        "tab": "Dataset Resource",
        "name": "Temporal Coverage",
        "ref_cell": "B23",
        "value_cell": "F23",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_temporal_coverage.value,
    },
    MetaMapper.DATASET_sensitivity_status_for_dataset_resource.value: {
        "tab": "Dataset Resource",
        "name": "Sensitivity status for Dataset Resource",
        "ref_cell": "B36",
        "value_cell": "F36",
        "mandatory": True,
        "enum": ["Low", "Medium", "High"],
        "datatype": str,
        "std_name": MetaMapper.DATASET_sensitivity_status_for_dataset_resource.value,
    },
    MetaMapper.DATASET_sensitivity_tool_url.value: {
        "tab": "Dataset Resource",
        "name": "Sensitivity tool URL",
        "ref_cell": "B17",
        "value_cell": "F17",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_sensitivity_tool_url.value,
    },
    MetaMapper.DATASET_retention_date.value: {
        "tab": "Dataset Resource",
        "name": "Retention Date",
        "ref_cell": "B55",
        "value_cell": "F55",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_retention_date.value,
    },
    MetaMapper.DATASET_provider_statement_for_retention_removal_or_deletion.value: {
        "tab": "Dataset Resource",
        "name": "Provider statement for retention, removal or deletion",
        "ref_cell": "B50",
        "value_cell": "F50",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_provider_statement_for_retention_removal_or_deletion.value,
    },
    MetaMapper.DATASET_removal_date.value: {
        "tab": "Dataset Resource",
        "name": "Removal Date",
        "ref_cell": "B51",
        "value_cell": "F51",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_removal_date.value,
    },
    MetaMapper.DATASET_removal_comments.value: {
        "tab": "Dataset Resource",
        "name": "Removal Comments",
        "ref_cell": "B52",
        "value_cell": "F52",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_removal_comments.value,
    },
    MetaMapper.DATASET_data_controller.value: {
        "tab": "Dataset Resource",
        "name": "Data Controller",
        "ref_cell": "B31",
        "value_cell": "F31",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_controller.value,
    },
    MetaMapper.DATASET_data_processor.value: {
        "tab": "Dataset Resource",
        "name": "Data Processor",
        "ref_cell": "B32",
        "value_cell": "F32",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_data_processor.value,
    },
    MetaMapper.DATASET_dataset_domain.value: {
        "tab": "Dataset Resource",
        "name": "Dataset Domain",
        "ref_cell": "B19",
        "value_cell": "F19",
        "mandatory": True,
        "enum": [
            "Crime and Justice",
            "Economics",
            "Government finance, Fiscal and Public Sector finances",
            "Human settlements and housing",
            "Income and Consumption",
            "Education ",
            "Health ",
            "Labour",
            "Population and Migration",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_dataset_domain.value,
    },
    MetaMapper.DATASET_legal_gateway.value: {
        "tab": "Dataset Resource",
        "name": "Legal Gateway",
        "ref_cell": "B33",
        "value_cell": "F33",
        "mandatory": False,
        "enum": [
            "Digital Economy Act 2017",
            "Statistics and Registration Service Act 2007",
            "NHS Act 2006",
            "NHS Act 2006 with COPI Regulations 2002, Reg 3(4)",
            "Health and Social Care Act 2012",
            "Education Act 1996 / 2011",
            "Education and Skills Act 2008",
            "Children's Act 1989",
            "Legal Gateway Not Required",
            "Other",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_legal_gateway.value,
    },
    MetaMapper.DATASET_other_legal_gateway.value: {
        "tab": "Dataset Resource",
        "name": "Other Legal Gateway",
        "ref_cell": "B34",
        "value_cell": "F34",
        "mandatory": False,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_other_legal_gateway.value,
    },
    MetaMapper.DATASET_licensing_status.value: {
        "tab": "Dataset Resource",
        "name": "Licensing status",
        "ref_cell": "B35",
        "value_cell": "F35",
        "mandatory": False,
        "enum": [
            "Open Data Commons Open Database License (ODbL)",
            "Open Government Licence v3.0",
            "Open Government Licence v2.0",
            "Open Government Licence v1.0",
            "Statistics and Registration Service Act 2007",
            "Non-Commercial Government Licence v2.0",
            "Non-Commercial Government Licence v1.0",
            "Developer Licence 2.0",
            "Developer Licence 1.0",
            "Charged Licence",
            "Open Supreme Court Licence",
            "Restricted",
            "Memorandum of Understanding (MoU)",
        ],
        "datatype": str,
        "std_name": MetaMapper.DATASET_licensing_status.value,
    },
    MetaMapper.DATASET_documentation.value: {
        "tab": "Dataset Resource",
        "name": "Documentation",
        "ref_cell": "B100",
        "value_cell": "F100",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_documentation.value,
    },
    MetaMapper.DATASET_what_are_the_linkage_requirements_for_the_data_within_the_project_scope.value: {
        "tab": "Dataset Resource",
        "name": "What are the linkage requirements for the data within the project scope?",
        "ref_cell": "B65",
        "value_cell": "F65",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_what_are_the_linkage_requirements_for_the_data_within_the_project_scope.value,
    },
    MetaMapper.DATASET_how_has_deidentification_been_achieved.value: {
        "tab": "Dataset Resource",
        "name": "How has deidentification been achieved",
        "ref_cell": "B77",
        "value_cell": "F77",
        "mandatory": True,
        "enum": [],
        "datatype": str,
        "std_name": MetaMapper.DATASET_how_has_deidentification_been_achieved.value,
    },
}
